=== debian/changelog ===
gammaray (2.5.1-1~build1) yakkety; urgency=medium

  * Upload to Ubuntu yakkety
  * New upstream release.
  * Fix FTBFS on armel and armhf.

 -- Jakub Adam <jakub.adam@ktknet.cz>  Thu, 28 Jul 2016 07:29:38 +0200
